      subroutine A02evolve(xb,Q,fset)
      implicit none
      integer npdf,npar,kschem,i,k,n,m
      integer nxb,nq,np,nvar,pdfset,iset
      parameter(nxb=59,nq=40,np=9,nvar=15)
      character*16 name
      integer nmem,ndef
      common/NAME/name,nmem,ndef
      real*4 f(0:nvar,nxb,nq+1,0:np),qq(nq),xx(nxb)
      real*8 pdfs(np),fset(-6:6),alfas
      real*8 x,Q,xb,q2,xmin,xmax,qsq,qsqmin,qsqmax,a,b
      data xx/1d-7,2d-7,4d-7,6d-7,8d-7,
     .        1d-6,2d-6,4d-6,6d-6,8d-6,
     .        1d-5,2d-5,4d-5,6d-5,8d-5,
     .        1d-4,2d-4,4d-4,6d-4,8d-4,
     .        1d-3,2d-3,4d-3,6d-3,8d-3,
     .        1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2,
     .     .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,
     .     .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0,
     .     .5d0,.525d0,.55d0,.575d0,.6d0,.65d0,.7d0,.75d0,
     .     .8d0,.9d0,1d0/
      data qq/1.4d0,1.7d0,2d0,2.4d0,2.9d0,3.6d0,4.5d0,5.6d0,7.1d0,9.2d0,
     ,        1.2d1,1.6d1,2.1d1,2.8d1,3.9d1,5.4d1,7.6d1,
     ,        1.1d2,1.6d2,2.4d2,3.7d2,5.7d2,9.0d2,
     ,        1.5d3,2.4d3,4.1d3,7.2d3,
     ,        1.3d4,2.4d4,4.5d4,8.9d4,
     ,        1.8d5,3.8d5,8.2d5,
     ,        1.8d6,4.3d6,
     ,        1.1d7,2.7d7,7.2d7,
     ,        2d8/
      data xmin,xmax,qsqmin,qsqmax/1d-7,1d0,1.4d0,2d8/
      save f,npdf,npar,pdfset

      q2=Q*Q
      if(q2.lt.qsqmin.or.q2.gt.qsqmax) print 99,q2
      if(xb.lt.xmin.or.xb.gt.xmax)       print 98,x
  99  format('  WARNING:  Q^2 VALUE IS OUT OF RANGE   ')
  98  format('  WARNING:   X  VALUE IS OUT OF RANGE   ')

      x=max(xb,xmin)
      x=min(xb,xmax)
      qsq=max(q2,qsqmin)
      qsq=min(q2,qsqmax)
      n=0
  70  n=n+1
      if(x.gt.xx(n+1)) goto 70
      a=(x-xx(n))/(xx(n+1)-xx(n))
      m=0
  80  m=m+1
      if(qsq.gt.qq(m+1)) goto 80
      b=(qsq-qq(m))/(qq(m+1)-qq(m))
      k=pdfset
      do i=1,npdf
         pdfs(i)=(1d0-a)*(1d0-b)*f(k,n,m,i)+(1d0-a)*b*f(k,n,m+1,i)
     .          +a*(1d0-b)*f(k,n+1,m,i)+a*b*f(k,n+1,m+1,i)
      end do
      fset(-6)=pdfs(9)
      fset(-5)=pdfs(8)
      fset(-4)=pdfs(7)
      fset(-3)=pdfs(5)
c - 1 and 2 reversed due to error, fset 1 = down, 2 = up, mrw 7/4/2004
      fset(-1)=pdfs(6)
      fset(-2)=pdfs(4)
      fset(0)=pdfs(3)
      fset(2)=pdfs(1)+pdfs(4)
      fset(1)=pdfs(2)+pdfs(6)
      fset(3)=pdfs(5)
      fset(4)=pdfs(7)
      fset(5)=pdfs(8)
      fset(6)=pdfs(9)
      return
*
      entry A02alfa(alfas,Q)
      q2=Q*Q
      if(q2.lt.qsqmin.or.q2.gt.qsqmax) print 99,q2
      qsq=max(q2,qsqmin)
      qsq=min(q2,qsqmax)
      m=0
 90   m=m+1
      if(qsq.gt.qq(m+1)) goto 90
      b=(qsq-qq(m))/(qq(m+1)-qq(m))
      k=pdfset
      alfas=(1d0-b)*f(k,1,m,0)+b*f(k,1,m+1,0)
      return
*
      entry A02read
      nmem = nvar + 1
      ndef = 0
      read(1,*) npdf
      npar=nvar
      do k=0,npar
         do n=1,nxb-1
            do m=1,nq
               read(1,100) (f(k,n,m,i),i=0,npdf)
            enddo
         enddo
      enddo
  100 format (13f11.5)
      return
*
      entry A02init
      do i=1,npdf
         do m=1,nq
            do k=1,npar
               f(k,nxb,m,i)=0d0
            end do
         end do
         do m=1,nq
            do k=1,npar
               f(k,nxb,m,0)=f(k,nxb-1,m,0)
            end do
         end do
      end do
      return
*
      entry A02pdf(iset)
      pdfset=iset
      if ((pdfset.lt.0).or.(pdfset.gt.npar)) then
         write(*,*) 'A02 PDF set:'
         write(*,*) 'PDF member out of range:'
         write(*,*) 'member = ',pdfset,'    member range = (0,',npar,')'
         stop
      endif
      return
      end
