      subroutine evolvePDF(x,Q,f)
      implicit none
      integer Eorder,index
      real*8 x,Q,Q2fit,alfas
      real*8 f(-6:6)
*
* Evolving the PDF's
* To get PDF values f(index) at momentum fraction x (and scale Q2fit):
*     call parmPDF(x,f)
*
      call parmPDF(x,f)
* Add the evolution code to evolve PDF's f from scale Q2fit to scale Q2
      return
*
      entry readevolve
* Read evolution specific instructions/parameters from input file
      return
*
      entry alfasevolve(alfas,Q)
* Returns alfas at scale Q. This code only has to be entered if
* the internal alpha_S code (in alphas.f) is not used (this is
* specified in the input file).
      return
*
      entry initevolution(Eorder,Q2fit)
* Initialize PDF independent part of evolution code
* Eorder gives evolution order (0=lo, 1=nlo, 2=nnlo)
* Q2fit is the square of the scale to which
*
* Put call to evolution code initialization
*
      write(*,*) '**************************************************'
      write(*,*) '* Template to evolution code is selected         *'
      write(*,*) '* The call evolvePDF(x,Q,f) will return the      *'
      write(*,*) '* unevolved PDFs at parton fraction x            *'
      write(*,*) '**************************************************'
      return
*
      entry initevolvePDF
* Initialize evolution code for specific PDF
* To get PDF input:
*     call GetParmPDF(alfas0,scale0)
* To get flavor treshold Qt for flavor index:
*     call GetThreshold(index,Qt) (if Qt=0d0 no threshold is set)
* To get PDF values f(index) at momentum fraction x:
*     call parmPDF(x,f)
*
* Put call to initialize the evolution code for the specified PDF here
*
      return
*
      end
